// Copyright (C) 2018-2020 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License along
// with this library; see the file COPYING3.  If not see
// <http://www.gnu.org/licenses/>.

// { dg-options "-std=gnu++2a -O2" }
// { dg-do compile { target c++2a } }
// { dg-final { scan-assembler-not "undefined" } }

#include <memory>

int* ptr();
extern "C" void undefined();

void
test01()
{
  const std::size_t alignment = 4 * alignof(int);
  int* p = std::assume_aligned<alignment>(ptr());
  if ((std::uintptr_t)p % alignment)
    undefined();
}
