// Copyright (C) 2019-2020 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License along
// with this library; see the file COPYING3.  If not see
// <http://www.gnu.org/licenses/>.

// { dg-options "-std=gnu++2a" }
// { dg-do compile { target c++2a } }

#undef _GLIBCXX_ASSERTIONS
#define _GLIBCXX_ASSERTIONS
#include <span>

constexpr bool
test01(bool b)
{
  std::span<int, 0> s;
  if (b || !s.empty())
    s.back();
  return true;
}

static_assert(test01(false));
static_assert(test01(true)); // { dg-error "non-constant" }
// { dg-error "assert" "" { target *-*-* } 0 }
// { dg-prune-output "in 'constexpr' expansion" }
