// Copyright (C) 2020 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License along
// with this library; see the file COPYING3.  If not see
// <http://www.gnu.org/licenses/>.

// { dg-options "-std=gnu++2a" }
// { dg-do run { target c++2a } }
// { dg-require-gthreads {} }
// { dg-additional-options "-pthread" { target pthread } }
// { dg-additional-options "-static" { target static } }

#include <thread>

// PR libstdc++/95989
// Segfault compiling with static libraries and using jthread::request_stop

void
test01()
{
  std::jthread t{ [] () {} };
}

void
test02()
{
  std::jthread t{ [] () {} };
  t.request_stop();
}

void
test03()
{
  std::jthread t{ [] {} };
  std::stop_callback cb(t.get_stop_token(), [] () {});
}

int
main()
{
  test01();
  test01();
}
